/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.0.0
 * @date    2020-08-02T17:48:43.502Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}function r(t){return t&&t.default||t}var n=function(t){return t&&t.Math==Math&&t},o=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof t&&t)||Function("return this")(),i=function(t){try{return!!t()}catch(t){return!0}},a=!i((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),u={}.propertyIsEnumerable,c=Object.getOwnPropertyDescriptor,s={f:c&&!u.call({1:2},1)?function(t){var e=c(this,t);return!!e&&e.enumerable}:u},f=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},l={}.toString,h=function(t){return l.call(t).slice(8,-1)},p="".split,v=i((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==h(t)?p.call(t,""):Object(t)}:Object,d=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},y=function(t){return v(d(t))},g=function(t){return"object"==typeof t?null!==t:"function"==typeof t},m=function(t,e){if(!g(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!g(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!g(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!g(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},b={}.hasOwnProperty,_=function(t,e){return b.call(t,e)},w=o.document,O=g(w)&&g(w.createElement),x=function(t){return O?w.createElement(t):{}},k=!a&&!i((function(){return 7!=Object.defineProperty(x("div"),"a",{get:function(){return 7}}).a})),S=Object.getOwnPropertyDescriptor,j={f:a?S:function(t,e){if(t=y(t),e=m(e,!0),k)try{return S(t,e)}catch(t){}if(_(t,e))return f(!s.f.call(t,e),t[e])}},A=/#|\.prototype\./,E=function(t,e){var r=I[P(t)];return r==L||r!=T&&("function"==typeof e?i(e):!!e)},P=E.normalize=function(t){return String(t).replace(A,".").toLowerCase()},I=E.data={},T=E.NATIVE="N",L=E.POLYFILL="P",D=E,M={},C=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},F=function(t,e,r){if(C(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,o){return t.call(e,r,n,o)}}return function(){return t.apply(e,arguments)}},R=function(t){if(!g(t))throw TypeError(String(t)+" is not an object");return t},N=Object.defineProperty,q={f:a?N:function(t,e,r){if(R(t),e=m(e,!0),R(r),k)try{return N(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},z=a?function(t,e,r){return q.f(t,e,f(1,r))}:function(t,e,r){return t[e]=r,t},G=j.f,U=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},V=function(t,e){var r,n,i,a,u,c,s,f,l=t.target,h=t.global,p=t.stat,v=t.proto,d=h?o:p?o[l]:(o[l]||{}).prototype,y=h?M:M[l]||(M[l]={}),g=y.prototype;for(i in e)r=!D(h?i:l+(p?".":"#")+i,t.forced)&&d&&_(d,i),u=y[i],r&&(c=t.noTargetGet?(f=G(d,i))&&f.value:d[i]),a=r&&c?c:e[i],r&&typeof u==typeof a||(s=t.bind&&r?F(a,o):t.wrap&&r?U(a):v&&"function"==typeof a?F(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&z(s,"sham",!0),y[i]=s,v&&(_(M,n=l+"Prototype")||z(M,n,{}),M[n][i]=a,t.real&&g&&!g[i]&&z(g,i,a)))},J=Array.isArray||function(t){return"Array"==h(t)},$=Math.ceil,W=Math.floor,B=function(t){return isNaN(t=+t)?0:(t>0?W:$)(t)},K=Math.min,Y=function(t){return t>0?K(B(t),9007199254740991):0},H=function(t,e,r,n,o,i,a,u){for(var c,s=o,f=0,l=!!a&&F(a,u,3);f<n;){if(f in r){if(c=l?l(r[f],f,e):r[f],i>0&&J(c))s=H(t,e,c,Y(c.length),s,i-1)-1;else{if(s>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[s]=c}s++}f++}return s},Q=H,X=function(t){return Object(d(t))},Z=o["__core-js_shared__"]||function(t,e){try{z(o,t,e)}catch(r){o[t]=e}return e}("__core-js_shared__",{}),tt=e((function(t){(t.exports=function(t,e){return Z[t]||(Z[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),et=0,rt=Math.random(),nt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++et+rt).toString(36)},ot=!!Object.getOwnPropertySymbols&&!i((function(){return!String(Symbol())})),it=ot&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,at=tt("wks"),ut=o.Symbol,ct=it?ut:ut&&ut.withoutSetter||nt,st=function(t){return _(at,t)||(ot&&_(ut,t)?at[t]=ut[t]:at[t]=ct("Symbol."+t)),at[t]},ft=st("species"),lt=function(t,e){var r;return J(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!J(r.prototype)?g(r)&&null===(r=r[ft])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)};V({target:"Array",proto:!0},{flatMap:function(t){var e,r=X(this),n=Y(r.length);return C(t),(e=lt(r,0)).length=Q(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var ht,pt,vt=function(t){return M[t+"Prototype"]},dt=vt("Array").flatMap,yt=Array.prototype,gt=function(t){var e=t.flatMap;return t===yt||t instanceof Array&&e===yt.flatMap?dt:e},mt=[].push,bt=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=5==t||i;return function(u,c,s,f){for(var l,h,p=X(u),d=v(p),y=F(c,s,3),g=Y(d.length),m=0,b=f||lt,_=e?b(u,g):r?b(u,0):void 0;g>m;m++)if((a||m in d)&&(h=y(l=d[m],m,p),t))if(e)_[m]=h;else if(h)switch(t){case 3:return!0;case 5:return l;case 6:return m;case 2:mt.call(_,l)}else if(o)return!1;return i?-1:n||o?o:_}},_t={forEach:bt(0),map:bt(1),filter:bt(2),some:bt(3),every:bt(4),find:bt(5),findIndex:bt(6)},wt=function(t){return"function"==typeof t?t:void 0},Ot=function(t,e){return arguments.length<2?wt(M[t])||wt(o[t]):M[t]&&M[t][e]||o[t]&&o[t][e]},xt=Ot("navigator","userAgent")||"",kt=o.process,St=kt&&kt.versions,jt=St&&St.v8;jt?pt=(ht=jt.split("."))[0]+ht[1]:xt&&(!(ht=xt.match(/Edge\/(\d+)/))||ht[1]>=74)&&(ht=xt.match(/Chrome\/(\d+)/))&&(pt=ht[1]);var At=pt&&+pt,Et=st("species"),Pt=function(t){return At>=51||!i((function(){var e=[];return(e.constructor={})[Et]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},It=Object.defineProperty,Tt={},Lt=function(t){throw t},Dt=function(t,e){if(_(Tt,t))return Tt[t];e||(e={});var r=[][t],n=!!_(e,"ACCESSORS")&&e.ACCESSORS,o=_(e,0)?e[0]:Lt,u=_(e,1)?e[1]:void 0;return Tt[t]=!!r&&!i((function(){if(n&&!a)return!0;var t={length:-1};n?It(t,1,{enumerable:!0,get:Lt}):t[1]=1,r.call(t,o,u)}))},Mt=_t.map,Ct=Pt("map"),Ft=Dt("map");V({target:"Array",proto:!0,forced:!Ct||!Ft},{map:function(t){return Mt(this,t,arguments.length>1?arguments[1]:void 0)}});var Rt=vt("Array").map,Nt=Array.prototype,qt=function(t){var e=t.map;return t===Nt||t instanceof Array&&e===Nt.map?Rt:e},zt=_t.filter,Gt=Pt("filter"),Ut=Dt("filter");V({target:"Array",proto:!0,forced:!Gt||!Ut},{filter:function(t){return zt(this,t,arguments.length>1?arguments[1]:void 0)}});var Vt=vt("Array").filter,Jt=Array.prototype,$t=function(t){var e=t.filter;return t===Jt||t instanceof Array&&e===Jt.filter?Vt:e},Wt=function(t){return function(e,r,n,o){C(r);var i=X(e),a=v(i),u=Y(i.length),c=t?u-1:0,s=t?-1:1;if(n<2)for(;;){if(c in a){o=a[c],c+=s;break}if(c+=s,t?c<0:u<=c)throw TypeError("Reduce of empty array with no initial value")}for(;t?c>=0:u>c;c+=s)c in a&&(o=r(o,a[c],c,i));return o}},Bt=function(t,e){var r=[][t];return!!r&&i((function(){r.call(null,e||function(){throw 1},1)}))},Kt={left:Wt(!1),right:Wt(!0)}.left,Yt=Bt("reduce"),Ht=Dt("reduce",{1:0});V({target:"Array",proto:!0,forced:!Yt||!Ht},{reduce:function(t){return Kt(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Qt=vt("Array").reduce,Xt=Array.prototype,Zt=function(t){var e=t.reduce;return t===Xt||t instanceof Array&&e===Xt.reduce?Qt:e},te=[].slice,ee={},re=function(t,e,r){if(!(e in ee)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";ee[e]=Function("C,a","return new C("+n.join(",")+")")}return ee[e](t,r)},ne=Function.bind||function(t){var e=C(this),r=te.call(arguments,1),n=function(){var o=r.concat(te.call(arguments));return this instanceof n?re(e,o.length,o):e.apply(t,o)};return g(e.prototype)&&(n.prototype=e.prototype),n};V({target:"Function",proto:!0},{bind:ne});var oe=vt("Function").bind,ie=Function.prototype,ae=function(t){var e=t.bind;return t===ie||t instanceof Function&&e===ie.bind?oe:e};var ue=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};V({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperty:q.f});var ce=e((function(t){var e=M.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),se=ce;function fe(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),se(t,n.key,n)}}var le=function(t,e,r){return e&&fe(t.prototype,e),r&&fe(t,r),t};function he(t){return new ve(t)}var pe=function(){function t(e,r,n){var o,i,a;ue(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:ae(o=this._add).call(o,this),remove:ae(i=this._remove).call(i,this),update:ae(a=this._update).call(a,this)}}return le(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Zt(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),ve=function(){function t(e){ue(this,t),this._source=e,this._transformers=[]}return le(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return $t(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return qt(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return gt(e).call(e,t)})),this}},{key:"to",value:function(t){return new pe(this._source,this._transformers,t)}}]),t}(),de=ce,ye=Math.max,ge=Math.min,me=function(t,e){var r=B(t);return r<0?ye(r+e,0):ge(r,e)},be=function(t){return function(e,r,n){var o,i=y(e),a=Y(i.length),u=me(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},_e={includes:be(!0),indexOf:be(!1)},we={},Oe=_e.indexOf,xe=function(t,e){var r,n=y(t),o=0,i=[];for(r in n)!_(we,r)&&_(n,r)&&i.push(r);for(;e.length>o;)_(n,r=e[o++])&&(~Oe(i,r)||i.push(r));return i},ke=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Se=Object.keys||function(t){return xe(t,ke)},je=a?Object.defineProperties:function(t,e){R(t);for(var r,n=Se(e),o=n.length,i=0;o>i;)q.f(t,r=n[i++],e[r]);return t};V({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperties:je});var Ae=e((function(t){var e=M.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),Ee=ke.concat("length","prototype"),Pe={f:Object.getOwnPropertyNames||function(t){return xe(t,Ee)}},Ie={f:Object.getOwnPropertySymbols},Te=Ot("Reflect","ownKeys")||function(t){var e=Pe.f(R(t)),r=Ie.f;return r?e.concat(r(t)):e},Le=function(t,e,r){var n=m(e);n in t?q.f(t,n,f(0,r)):t[n]=r};V({target:"Object",stat:!0,sham:!a},{getOwnPropertyDescriptors:function(t){for(var e,r,n=y(t),o=j.f,i=Te(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&Le(a,e,r);return a}});var De=M.Object.getOwnPropertyDescriptors,Me={},Ce=Function.toString;"function"!=typeof Z.inspectSource&&(Z.inspectSource=function(t){return Ce.call(t)});var Fe,Re,Ne,qe=Z.inspectSource,ze=o.WeakMap,Ge="function"==typeof ze&&/native code/.test(qe(ze)),Ue=tt("keys"),Ve=function(t){return Ue[t]||(Ue[t]=nt(t))},Je=o.WeakMap;if(Ge){var $e=new Je,We=$e.get,Be=$e.has,Ke=$e.set;Fe=function(t,e){return Ke.call($e,t,e),e},Re=function(t){return We.call($e,t)||{}},Ne=function(t){return Be.call($e,t)}}else{var Ye=Ve("state");we[Ye]=!0,Fe=function(t,e){return z(t,Ye,e),e},Re=function(t){return _(t,Ye)?t[Ye]:{}},Ne=function(t){return _(t,Ye)}}var He,Qe,Xe,Ze={set:Fe,get:Re,has:Ne,enforce:function(t){return Ne(t)?Re(t):Fe(t,{})},getterFor:function(t){return function(e){var r;if(!g(e)||(r=Re(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},tr=!i((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),er=Ve("IE_PROTO"),rr=Object.prototype,nr=tr?Object.getPrototypeOf:function(t){return t=X(t),_(t,er)?t[er]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?rr:null},or=(st("iterator"),!1);[].keys&&("next"in(Xe=[].keys())?(Qe=nr(nr(Xe)))!==Object.prototype&&(He=Qe):or=!0),null==He&&(He={});var ir,ar={IteratorPrototype:He,BUGGY_SAFARI_ITERATORS:or},ur=Ot("document","documentElement"),cr=Ve("IE_PROTO"),sr=function(){},fr=function(t){return"<script>"+t+"<\/script>"},lr=function(){try{ir=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;lr=ir?function(t){t.write(fr("")),t.close();var e=t.parentWindow.Object;return t=null,e}(ir):((e=x("iframe")).style.display="none",ur.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(fr("document.F=Object")),t.close(),t.F);for(var r=ke.length;r--;)delete lr.prototype[ke[r]];return lr()};we[cr]=!0;var hr=Object.create||function(t,e){var r;return null!==t?(sr.prototype=R(t),r=new sr,sr.prototype=null,r[cr]=t):r=lr(),void 0===e?r:je(r,e)},pr={};pr[st("toStringTag")]="z";var vr="[object z]"===String(pr),dr=st("toStringTag"),yr="Arguments"==h(function(){return arguments}()),gr=vr?h:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),dr))?r:yr?h(e):"Object"==(n=h(e))&&"function"==typeof e.callee?"Arguments":n},mr=vr?{}.toString:function(){return"[object "+gr(this)+"]"},br=q.f,_r=st("toStringTag"),wr=function(t,e,r,n){if(t){var o=r?t:t.prototype;_(o,_r)||br(o,_r,{configurable:!0,value:e}),n&&!vr&&z(o,"toString",mr)}},Or=ar.IteratorPrototype,xr=function(){return this},kr=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return R(r),function(t){if(!g(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),Sr=function(t,e,r,n){n&&n.enumerable?t[e]=r:z(t,e,r)},jr=ar.IteratorPrototype,Ar=ar.BUGGY_SAFARI_ITERATORS,Er=st("iterator"),Pr=function(){return this},Ir=function(t,e,r,n,o,i,a){!function(t,e,r){var n=e+" Iterator";t.prototype=hr(Or,{next:f(1,r)}),wr(t,n,!1,!0),Me[n]=xr}(r,e,n);var u,c,s,l=function(t){if(t===o&&y)return y;if(!Ar&&t in v)return v[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",p=!1,v=t.prototype,d=v[Er]||v["@@iterator"]||o&&v[o],y=!Ar&&d||l(o),g="Array"==e&&v.entries||d;if(g&&(u=nr(g.call(new t)),jr!==Object.prototype&&u.next&&(wr(u,h,!0,!0),Me[h]=Pr)),"values"==o&&d&&"values"!==d.name&&(p=!0,y=function(){return d.call(this)}),a&&v[Er]!==y&&z(v,Er,y),Me[e]=y,o)if(c={values:l("values"),keys:i?y:l("keys"),entries:l("entries")},a)for(s in c)(Ar||p||!(s in v))&&Sr(v,s,c[s]);else V({target:e,proto:!0,forced:Ar||p},c);return c},Tr=Ze.set,Lr=Ze.getterFor("Array Iterator");Ir(Array,"Array",(function(t,e){Tr(this,{type:"Array Iterator",target:y(t),index:0,kind:e})}),(function(){var t=Lr(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");Me.Arguments=Me.Array;var Dr=st("toStringTag");for(var Mr in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Cr=o[Mr],Fr=Cr&&Cr.prototype;Fr&&gr(Fr)!==Dr&&z(Fr,Dr,Mr),Me[Mr]=Me.Array}var Rr=_t.forEach,Nr=Bt("forEach"),qr=Dt("forEach"),zr=Nr&&qr?[].forEach:function(t){return Rr(this,t,arguments.length>1?arguments[1]:void 0)};V({target:"Array",proto:!0,forced:[].forEach!=zr},{forEach:zr});var Gr=vt("Array").forEach,Ur=Array.prototype,Vr={DOMTokenList:!0,NodeList:!0},Jr=function(t){var e=t.forEach;return t===Ur||t instanceof Array&&e===Ur.forEach||Vr.hasOwnProperty(gr(t))?Gr:e},$r=j.f,Wr=i((function(){$r(1)}));V({target:"Object",stat:!0,forced:!a||Wr,sham:!a},{getOwnPropertyDescriptor:function(t,e){return $r(y(t),e)}});var Br=e((function(t){var e=M.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),Kr=Pe.f,Yr={}.toString,Hr="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Qr={f:function(t){return Hr&&"[object Window]"==Yr.call(t)?function(t){try{return Kr(t)}catch(t){return Hr.slice()}}(t):Kr(y(t))}},Xr={f:st},Zr=q.f,tn=function(t){var e=M.Symbol||(M.Symbol={});_(e,t)||Zr(e,t,{value:Xr.f(t)})},en=_t.forEach,rn=Ve("hidden"),nn=st("toPrimitive"),on=Ze.set,an=Ze.getterFor("Symbol"),un=Object.prototype,cn=o.Symbol,sn=Ot("JSON","stringify"),fn=j.f,ln=q.f,hn=Qr.f,pn=s.f,vn=tt("symbols"),dn=tt("op-symbols"),yn=tt("string-to-symbol-registry"),gn=tt("symbol-to-string-registry"),mn=tt("wks"),bn=o.QObject,_n=!bn||!bn.prototype||!bn.prototype.findChild,wn=a&&i((function(){return 7!=hr(ln({},"a",{get:function(){return ln(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=fn(un,e);n&&delete un[e],ln(t,e,r),n&&t!==un&&ln(un,e,n)}:ln,On=function(t,e){var r=vn[t]=hr(cn.prototype);return on(r,{type:"Symbol",tag:t,description:e}),a||(r.description=e),r},xn=it?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof cn},kn=function(t,e,r){t===un&&kn(dn,e,r),R(t);var n=m(e,!0);return R(r),_(vn,n)?(r.enumerable?(_(t,rn)&&t[rn][n]&&(t[rn][n]=!1),r=hr(r,{enumerable:f(0,!1)})):(_(t,rn)||ln(t,rn,f(1,{})),t[rn][n]=!0),wn(t,n,r)):ln(t,n,r)},Sn=function(t,e){R(t);var r=y(e),n=Se(r).concat(Pn(r));return en(n,(function(e){a&&!jn.call(r,e)||kn(t,e,r[e])})),t},jn=function(t){var e=m(t,!0),r=pn.call(this,e);return!(this===un&&_(vn,e)&&!_(dn,e))&&(!(r||!_(this,e)||!_(vn,e)||_(this,rn)&&this[rn][e])||r)},An=function(t,e){var r=y(t),n=m(e,!0);if(r!==un||!_(vn,n)||_(dn,n)){var o=fn(r,n);return!o||!_(vn,n)||_(r,rn)&&r[rn][n]||(o.enumerable=!0),o}},En=function(t){var e=hn(y(t)),r=[];return en(e,(function(t){_(vn,t)||_(we,t)||r.push(t)})),r},Pn=function(t){var e=t===un,r=hn(e?dn:y(t)),n=[];return en(r,(function(t){!_(vn,t)||e&&!_(un,t)||n.push(vn[t])})),n};if(ot||(Sr((cn=function(){if(this instanceof cn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=nt(t),r=function(t){this===un&&r.call(dn,t),_(this,rn)&&_(this[rn],e)&&(this[rn][e]=!1),wn(this,e,f(1,t))};return a&&_n&&wn(un,e,{configurable:!0,set:r}),On(e,t)}).prototype,"toString",(function(){return an(this).tag})),Sr(cn,"withoutSetter",(function(t){return On(nt(t),t)})),s.f=jn,q.f=kn,j.f=An,Pe.f=Qr.f=En,Ie.f=Pn,Xr.f=function(t){return On(st(t),t)},a&&ln(cn.prototype,"description",{configurable:!0,get:function(){return an(this).description}})),V({global:!0,wrap:!0,forced:!ot,sham:!ot},{Symbol:cn}),en(Se(mn),(function(t){tn(t)})),V({target:"Symbol",stat:!0,forced:!ot},{for:function(t){var e=String(t);if(_(yn,e))return yn[e];var r=cn(e);return yn[e]=r,gn[r]=e,r},keyFor:function(t){if(!xn(t))throw TypeError(t+" is not a symbol");if(_(gn,t))return gn[t]},useSetter:function(){_n=!0},useSimple:function(){_n=!1}}),V({target:"Object",stat:!0,forced:!ot,sham:!a},{create:function(t,e){return void 0===e?hr(t):Sn(hr(t),e)},defineProperty:kn,defineProperties:Sn,getOwnPropertyDescriptor:An}),V({target:"Object",stat:!0,forced:!ot},{getOwnPropertyNames:En,getOwnPropertySymbols:Pn}),V({target:"Object",stat:!0,forced:i((function(){Ie.f(1)}))},{getOwnPropertySymbols:function(t){return Ie.f(X(t))}}),sn){var In=!ot||i((function(){var t=cn();return"[null]"!=sn([t])||"{}"!=sn({a:t})||"{}"!=sn(Object(t))}));V({target:"JSON",stat:!0,forced:In},{stringify:function(t,e,r){for(var n,o=[t],i=1;arguments.length>i;)o.push(arguments[i++]);if(n=e,(g(e)||void 0!==t)&&!xn(t))return J(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!xn(e))return e}),o[1]=e,sn.apply(null,o)}})}cn.prototype[nn]||z(cn.prototype,nn,cn.prototype.valueOf),wr(cn,"Symbol"),we[rn]=!0;var Tn=M.Object.getOwnPropertySymbols,Ln=function(t){return function(e,r){var n,o,i=String(d(e)),a=B(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=i.charCodeAt(a))<55296||n>56319||a+1===u||(o=i.charCodeAt(a+1))<56320||o>57343?t?i.charAt(a):n:t?i.slice(a,a+2):o-56320+(n-55296<<10)+65536}},Dn={codeAt:Ln(!1),charAt:Ln(!0)}.charAt,Mn=Ze.set,Cn=Ze.getterFor("String Iterator");Ir(String,"String",(function(t){Mn(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Cn(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=Dn(r,n),e.index+=t.length,{value:t,done:!1})}));var Fn=st("iterator"),Rn=function(t){if(null!=t)return t[Fn]||t["@@iterator"]||Me[gr(t)]},Nn=function(t){var e=Rn(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return R(e.call(t))},qn=Rn,zn=st("isConcatSpreadable"),Gn=At>=51||!i((function(){var t=[];return t[zn]=!1,t.concat()[0]!==t})),Un=Pt("concat"),Vn=function(t){if(!g(t))return!1;var e=t[zn];return void 0!==e?!!e:J(t)};V({target:"Array",proto:!0,forced:!Gn||!Un},{concat:function(t){var e,r,n,o,i,a=X(this),u=lt(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(Vn(i=-1===e?a:arguments[e])){if(c+(o=Y(i.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<o;r++,c++)r in i&&Le(u,c,i[r])}else{if(c>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Le(u,c++,i)}return u.length=c,u}});var Jn=Object.freeze({__proto__:null});tn("asyncIterator");var $n=Object.freeze({__proto__:null});tn("hasInstance"),tn("isConcatSpreadable"),tn("iterator"),tn("match"),tn("matchAll"),tn("replace"),tn("search"),tn("species"),tn("split"),tn("toPrimitive"),tn("toStringTag"),tn("unscopables"),wr(Math,"Math",!0),wr(o.JSON,"JSON",!0),r(Jn),r($n);var Wn=M.Symbol,Bn=Wn,Kn=function(t,e,r,n){try{return n?e(R(r)[0],r[1]):e(r)}catch(e){var o=t.return;throw void 0!==o&&R(o.call(t)),e}},Yn=st("iterator"),Hn=Array.prototype,Qn=function(t){return void 0!==t&&(Me.Array===t||Hn[Yn]===t)},Xn=st("iterator"),Zn=!1;try{var to=0,eo={next:function(){return{done:!!to++}},return:function(){Zn=!0}};eo[Xn]=function(){return this},Array.from(eo,(function(){throw 2}))}catch(t){}var ro=!function(t,e){if(!e&&!Zn)return!1;var r=!1;try{var n={};n[Xn]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));V({target:"Array",stat:!0,forced:ro},{from:function(t){var e,r,n,o,i,a,u=X(t),c="function"==typeof this?this:Array,s=arguments.length,f=s>1?arguments[1]:void 0,l=void 0!==f,h=Rn(u),p=0;if(l&&(f=F(f,s>2?arguments[2]:void 0,2)),null==h||c==Array&&Qn(h))for(r=new c(e=Y(u.length));e>p;p++)a=l?f(u[p],p):u[p],Le(r,p,a);else for(i=(o=h.call(u)).next,r=new c;!(n=i.call(o)).done;p++)a=l?Kn(o,f,[n.value,p],!0):n.value,Le(r,p,a);return r.length=p,r}});var no=M.Array.from,oo=no,io=Pt("slice"),ao=Dt("slice",{ACCESSORS:!0,0:0,1:2}),uo=st("species"),co=[].slice,so=Math.max;V({target:"Array",proto:!0,forced:!io||!ao},{slice:function(t,e){var r,n,o,i=y(this),a=Y(i.length),u=me(t,a),c=me(void 0===e?a:e,a);if(J(i)&&("function"!=typeof(r=i.constructor)||r!==Array&&!J(r.prototype)?g(r)&&null===(r=r[uo])&&(r=void 0):r=void 0,r===Array||void 0===r))return co.call(i,u,c);for(n=new(void 0===r?Array:r)(so(c-u,0)),o=0;u<c;u++,o++)u in i&&Le(n,o,i[u]);return n.length=o,n}});var fo=vt("Array").slice,lo=Array.prototype,ho=function(t){var e=t.slice;return t===lo||t instanceof Array&&e===lo.slice?fo:e},po=ho,vo=Ot("Reflect","construct"),yo=i((function(){function t(){}return!(vo((function(){}),[],t)instanceof t)})),go=!i((function(){vo((function(){}))})),mo=yo||go;V({target:"Reflect",stat:!0,forced:mo,sham:mo},{construct:function(t,e){C(t),R(e);var r=arguments.length<3?t:C(arguments[2]);if(go&&!yo)return vo(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(ne.apply(t,n))}var o=r.prototype,i=hr(g(o)?o:Object.prototype),a=Function.apply.call(t,i,e);return g(a)?a:i}});var bo=M.Reflect.construct,_o=vt("Array").entries,wo=Array.prototype,Oo={DOMTokenList:!0,NodeList:!0},xo=function(t){var e=t.entries;return t===wo||t instanceof Array&&e===wo.entries||Oo.hasOwnProperty(gr(t))?_o:e},ko=e((function(t){var e=function(t){var e=Object.prototype,r=e.hasOwnProperty,n="function"==typeof Symbol?Symbol:{},o=n.iterator||"@@iterator",i=n.asyncIterator||"@@asyncIterator",a=n.toStringTag||"@@toStringTag";function u(t,e,r,n){var o=e&&e.prototype instanceof f?e:f,i=Object.create(o.prototype),a=new O(n||[]);return i._invoke=function(t,e,r){var n="suspendedStart";return function(o,i){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===o)throw i;return k()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=b(a,r);if(u){if(u===s)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var f=c(t,e,r);if("normal"===f.type){if(n=r.done?"completed":"suspendedYield",f.arg===s)continue;return{value:f.arg,done:r.done}}"throw"===f.type&&(n="completed",r.method="throw",r.arg=f.arg)}}}(t,r,a),i}function c(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=u;var s={};function f(){}function l(){}function h(){}var p={};p[o]=function(){return this};var v=Object.getPrototypeOf,d=v&&v(v(x([])));d&&d!==e&&r.call(d,o)&&(p=d);var y=h.prototype=f.prototype=Object.create(p);function g(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function m(t,e){var n;this._invoke=function(o,i){function a(){return new e((function(n,a){!function n(o,i,a,u){var s=c(t[o],t,i);if("throw"!==s.type){var f=s.arg,l=f.value;return l&&"object"==typeof l&&r.call(l,"__await")?e.resolve(l.__await).then((function(t){n("next",t,a,u)}),(function(t){n("throw",t,a,u)})):e.resolve(l).then((function(t){f.value=t,a(f)}),(function(t){return n("throw",t,a,u)}))}u(s.arg)}(o,i,n,a)}))}return n=n?n.then(a,a):a()}}function b(t,e){var r=t.iterator[e.method];if(void 0===r){if(e.delegate=null,"throw"===e.method){if(t.iterator.return&&(e.method="return",e.arg=void 0,b(t,e),"throw"===e.method))return s;e.method="throw",e.arg=new TypeError("The iterator does not provide a 'throw' method")}return s}var n=c(r,t.iterator,e.arg);if("throw"===n.type)return e.method="throw",e.arg=n.arg,e.delegate=null,s;var o=n.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,s):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,s)}function _(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function w(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function O(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(_,this),this.reset(!0)}function x(t){if(t){var e=t[o];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var n=-1,i=function e(){for(;++n<t.length;)if(r.call(t,n))return e.value=t[n],e.done=!1,e;return e.value=void 0,e.done=!0,e};return i.next=i}}return{next:k}}function k(){return{value:void 0,done:!0}}return l.prototype=y.constructor=h,h.constructor=l,h[a]=l.displayName="GeneratorFunction",t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===l||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,h):(t.__proto__=h,a in t||(t[a]="GeneratorFunction")),t.prototype=Object.create(y),t},t.awrap=function(t){return{__await:t}},g(m.prototype),m.prototype[i]=function(){return this},t.AsyncIterator=m,t.async=function(e,r,n,o,i){void 0===i&&(i=Promise);var a=new m(u(e,r,n,o),i);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},g(y),y[a]="Generator",y[o]=function(){return this},y.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=x,O.prototype={constructor:O,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,this.tryEntries.forEach(w),!t)for(var e in this)"t"===e.charAt(0)&&r.call(this,e)&&!isNaN(+e.slice(1))&&(this[e]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function n(r,n){return a.type="throw",a.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],a=i.completion;if("root"===i.tryLoc)return n("end");if(i.tryLoc<=this.prev){var u=r.call(i,"catchLoc"),c=r.call(i,"finallyLoc");if(u&&c){if(this.prev<i.catchLoc)return n(i.catchLoc,!0);if(this.prev<i.finallyLoc)return n(i.finallyLoc)}else if(u){if(this.prev<i.catchLoc)return n(i.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return n(i.finallyLoc)}}}},abrupt:function(t,e){for(var n=this.tryEntries.length-1;n>=0;--n){var o=this.tryEntries[n];if(o.tryLoc<=this.prev&&r.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,s):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),s},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),w(r),s}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;w(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:x(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),s}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),So=Xr.f("iterator"),jo=So;var Ao=function(t,e,r){return e in t?se(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},Eo=Ot("JSON","stringify"),Po=/[\uD800-\uDFFF]/g,Io=/^[\uD800-\uDBFF]$/,To=/^[\uDC00-\uDFFF]$/,Lo=function(t,e,r){var n=r.charAt(e-1),o=r.charAt(e+1);return Io.test(t)&&!To.test(o)||To.test(t)&&!Io.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Do=i((function(){return'"\\udf06\\ud834"'!==Eo("\udf06\ud834")||'"\\udead"'!==Eo("\udead")}));Eo&&V({target:"JSON",stat:!0,forced:Do},{stringify:function(t,e,r){var n=Eo.apply(null,arguments);return"string"==typeof n?n.replace(Po,Lo):n}}),M.JSON||(M.JSON={stringify:JSON.stringify});var Mo=function(t,e,r){return M.JSON.stringify.apply(null,arguments)},Co=vt("Array").values,Fo=Array.prototype,Ro={DOMTokenList:!0,NodeList:!0},No=function(t){var e=t.values;return t===Fo||t instanceof Array&&e===Fo.values||Ro.hasOwnProperty(gr(t))?Co:e},qo=[],zo=qo.sort,Go=i((function(){qo.sort(void 0)})),Uo=i((function(){qo.sort(null)})),Vo=Bt("sort");V({target:"Array",proto:!0,forced:Go||!Uo||!Vo},{sort:function(t){return void 0===t?zo.call(X(this)):zo.call(X(this),C(t))}});var Jo=vt("Array").sort,$o=Array.prototype,Wo=function(t){var e=t.sort;return t===$o||t instanceof Array&&e===$o.sort?Jo:e},Bo=i((function(){Se(1)}));V({target:"Object",stat:!0,forced:Bo},{keys:function(t){return Se(X(t))}});var Ko=M.Object.keys,Yo=vt("Array").keys,Ho=Array.prototype,Qo={DOMTokenList:!0,NodeList:!0},Xo=function(t){var e=t.keys;return t===Ho||t instanceof Array&&e===Ho.keys||Qo.hasOwnProperty(gr(t))?Yo:e};V({target:"Array",stat:!0},{isArray:J});var Zo=M.Array.isArray,ti=Zo;var ei=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var ri=function(t){if(ti(t))return ei(t)},ni=no,oi=st("iterator"),ii=function(t){var e=Object(t);return void 0!==e[oi]||"@@iterator"in e||Me.hasOwnProperty(gr(e))};tn("asyncDispose"),tn("dispose"),tn("observable"),tn("patternMatch"),tn("replaceAll");var ai=Wn;var ui=function(t){if(void 0!==ai&&ii(Object(t)))return ni(t)},ci=ho;var si=function(t,e){var r;if(t){if("string"==typeof t)return ei(t,e);var n=ci(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?ni(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?ei(t,e):void 0}};var fi=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var li=function(t){return ri(t)||ui(t)||si(t)||fi()},hi=vt("Array").concat,pi=Array.prototype,vi=function(t){var e=t.concat;return t===pi||t instanceof Array&&e===pi.concat?hi:e},di=Object.assign,yi=Object.defineProperty,gi=!di||i((function(){if(a&&1!==di({b:1},di(yi({},"a",{enumerable:!0,get:function(){yi(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol();return t[r]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=di({},t)[r]||"abcdefghijklmnopqrst"!=Se(di({},e)).join("")}))?function(t,e){for(var r=X(t),n=arguments.length,o=1,i=Ie.f,u=s.f;n>o;)for(var c,f=v(arguments[o++]),l=i?Se(f).concat(i(f)):Se(f),h=l.length,p=0;h>p;)c=l[p++],a&&!u.call(f,c)||(r[c]=f[c]);return r}:di;V({target:"Object",stat:!0,forced:Object.assign!==gi},{assign:gi});var mi=M.Object.assign,bi=_t.some,_i=Bt("some"),wi=Dt("some");V({target:"Array",proto:!0,forced:!_i||!wi},{some:function(t){return bi(this,t,arguments.length>1?arguments[1]:void 0)}});var Oi=vt("Array").some,xi=Array.prototype,ki=function(t){var e=t.some;return t===xi||t instanceof Array&&e===xi.some?Oi:e},Si=So,ji=e((function(t){function e(r){return t.exports=e="function"==typeof ai&&"symbol"==typeof Si?function(t){return typeof t}:function(t){return t&&"function"==typeof ai&&t.constructor===ai&&t!==ai.prototype?"symbol":typeof t},e(r)}t.exports=e})),Ai=!i((function(){return Object.isExtensible(Object.preventExtensions({}))})),Ei=e((function(t){var e=q.f,r=nt("meta"),n=0,o=Object.isExtensible||function(){return!0},i=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!g(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!_(t,r)){if(!o(t))return"F";if(!e)return"E";i(t)}return t[r].objectID},getWeakData:function(t,e){if(!_(t,r)){if(!o(t))return!0;if(!e)return!1;i(t)}return t[r].weakData},onFreeze:function(t){return Ai&&a.REQUIRED&&o(t)&&!_(t,r)&&i(t),t}};we[r]=!0})),Pi=e((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,r,n,o,i){var a,u,c,s,f,l,h,p=F(r,n,o?2:1);if(i)a=t;else{if("function"!=typeof(u=Rn(t)))throw TypeError("Target is not iterable");if(Qn(u)){for(c=0,s=Y(t.length);s>c;c++)if((f=o?p(R(h=t[c])[0],h[1]):p(t[c]))&&f instanceof e)return f;return new e(!1)}a=u.call(t)}for(l=a.next;!(h=l.call(a)).done;)if("object"==typeof(f=Kn(a,p,h.value,o))&&f&&f instanceof e)return f;return new e(!1)}).stop=function(t){return new e(!0,t)}})),Ii=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},Ti=q.f,Li=_t.forEach,Di=Ze.set,Mi=Ze.getterFor,Ci=function(t,e,r){var n,u=-1!==t.indexOf("Map"),c=-1!==t.indexOf("Weak"),s=u?"set":"add",f=o[t],l=f&&f.prototype,h={};if(a&&"function"==typeof f&&(c||l.forEach&&!i((function(){(new f).entries().next()})))){n=e((function(e,r){Di(Ii(e,n,t),{type:t,collection:new f}),null!=r&&Pi(r,e[s],e,u)}));var p=Mi(t);Li(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||c&&"clear"==t||z(n.prototype,t,(function(r,n){var o=p(this).collection;if(!e&&c&&!g(r))return"get"==t&&void 0;var i=o[t](0===r?0:r,n);return e?this:i}))})),c||Ti(n.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else n=r.getConstructor(e,t,u,s),Ei.REQUIRED=!0;return wr(n,t,!1,!0),h[t]=n,V({global:!0,forced:!0},h),c||r.setStrong(n,t,u),n},Fi=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:Sr(t,n,e[n],r);return t},Ri=st("species"),Ni=q.f,qi=Ei.fastKey,zi=Ze.set,Gi=Ze.getterFor,Ui={getConstructor:function(t,e,r,n){var o=t((function(t,i){Ii(t,o,e),zi(t,{type:e,index:hr(null),first:void 0,last:void 0,size:0}),a||(t.size=0),null!=i&&Pi(i,t[n],t,r)})),i=Gi(e),u=function(t,e,r){var n,o,u=i(t),s=c(t,e);return s?s.value=r:(u.last=s={index:o=qi(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=s),n&&(n.next=s),a?u.size++:t.size++,"F"!==o&&(u.index[o]=s)),t},c=function(t,e){var r,n=i(t),o=qi(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return Fi(o.prototype,{clear:function(){for(var t=i(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,a?t.size=0:this.size=0},delete:function(t){var e=i(this),r=c(this,t);if(r){var n=r.next,o=r.previous;delete e.index[r.index],r.removed=!0,o&&(o.next=n),n&&(n.previous=o),e.first==r&&(e.first=n),e.last==r&&(e.last=o),a?e.size--:this.size--}return!!r},forEach:function(t){for(var e,r=i(this),n=F(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!c(this,t)}}),Fi(o.prototype,r?{get:function(t){var e=c(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),a&&Ni(o.prototype,"size",{get:function(){return i(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=Gi(e),i=Gi(n);Ir(t,e,(function(t,e){zi(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=i(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=Ot(t),r=q.f;a&&e&&!e[Ri]&&r(e,Ri,{configurable:!0,get:function(){return this}})}(e)}},Vi=(Ci("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ui),M.Map),Ji=Zo;V({target:"Object",stat:!0,sham:!a},{create:hr});var $i=M.Object,Wi=function(t,e){return $i.create(t,e)},Bi=Wi;V({target:"Object",stat:!0},{setPrototypeOf:kr});var Ki=M.Object.setPrototypeOf,Yi=e((function(t){function e(r,n){return t.exports=e=Ki||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var Hi=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Bi(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Yi(t,e)};var Qi=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Xi=function(t,e){return!e||"object"!==ji(e)&&"function"!=typeof e?Qi(t):e},Zi=i((function(){nr(1)}));V({target:"Object",stat:!0,forced:Zi,sham:!tr},{getPrototypeOf:function(t){return nr(X(t))}});var ta=M.Object.getPrototypeOf,ea=e((function(t){function e(r){return t.exports=e=Ki?ta:function(t){return t.__proto__||ta(t)},e(r)}t.exports=e})),ra="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),na=new Uint8Array(16);function oa(){if(!ra)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return ra(na)}var ia=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function aa(t){return"string"==typeof t&&ia.test(t)}for(var ua=[],ca=0;ca<256;++ca)ua.push((ca+256).toString(16).substr(1));function sa(t,e,r){var n=(t=t||{}).random||(t.rng||oa)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var o=0;o<16;++o)e[r+o]=n[o];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(ua[t[e+0]]+ua[t[e+1]]+ua[t[e+2]]+ua[t[e+3]]+"-"+ua[t[e+4]]+ua[t[e+5]]+"-"+ua[t[e+6]]+ua[t[e+7]]+"-"+ua[t[e+8]]+ua[t[e+9]]+"-"+ua[t[e+10]]+ua[t[e+11]]+ua[t[e+12]]+ua[t[e+13]]+ua[t[e+14]]+ua[t[e+15]]).toLowerCase();if(!aa(r))throw TypeError("Stringified UUID is invalid");return r}(n)}var fa,la=Wi,ha="\t\n\v\f\r                　\u2028\u2029\ufeff",pa="["+ha+"]",va=RegExp("^"+pa+pa+"*"),da=RegExp(pa+pa+"*$"),ya=function(t){return function(e){var r=String(d(e));return 1&t&&(r=r.replace(va,"")),2&t&&(r=r.replace(da,"")),r}},ga={start:ya(1),end:ya(2),trim:ya(3)},ma=ga.trim;V({target:"String",proto:!0,forced:(fa="trim",i((function(){return!!ha[fa]()||"​᠎"!="​᠎"[fa]()||ha[fa].name!==fa})))},{trim:function(){return ma(this)}});vt("String").trim;var ba=ga.trim,_a=o.parseInt,wa=/^[+-]?0[Xx]/,Oa=8!==_a(ha+"08")||22!==_a(ha+"0x16")?function(t,e){var r=ba(String(t));return _a(r,e>>>0||(wa.test(r)?16:10))}:_a;V({global:!0,forced:parseInt!=Oa},{parseInt:Oa});var xa=s.f,ka=function(t){return function(e){for(var r,n=y(e),o=Se(n),i=o.length,u=0,c=[];i>u;)r=o[u++],a&&!xa.call(n,r)||c.push(t?[r,n[r]]:n[r]);return c}},Sa={entries:ka(!0),values:ka(!1)}.values;V({target:"Object",stat:!0},{values:function(t){return Sa(t)}});M.Object.values;var ja=_e.indexOf,Aa=[].indexOf,Ea=!!Aa&&1/[1].indexOf(1,-0)<0,Pa=Bt("indexOf"),Ia=Dt("indexOf",{ACCESSORS:!0,1:0});V({target:"Array",proto:!0,forced:Ea||!Pa||!Ia},{indexOf:function(t){return Ea?Aa.apply(this,arguments)||0:ja(this,t,arguments.length>1?arguments[1]:void 0)}});vt("Array").indexOf;var Ta=function(t){if(ti(t))return t};var La=function(t,e){if(void 0!==ai&&ii(Object(t))){var r=[],n=!0,o=!1,i=void 0;try{for(var a,u=Nn(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){o=!0,i=t}finally{try{n||null==u.return||u.return()}finally{if(o)throw i}}return r}};var Da=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Ma=function(t,e){return Ta(t)||La(t,e)||si(t,e)||Da()};V({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});M.Date.now;V({target:"Reflect",stat:!0},{ownKeys:Te});var Ca=M.Reflect.ownKeys;function Fa(t,e){var r;if(void 0===Bn||null==qn(t)){if(Ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Ra(t,e);var n=po(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ra(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Ra(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
 * vis-util
 * https://github.com/visjs/vis-util
 *
 * utilitie collection for visjs
 *
 * @version 4.3.4
 * @date    2020-08-01T15:11:53.524Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var Na=Bn("DELETE");function qa(){var t=za.apply(void 0,arguments);return Ua(t),t}function za(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return za.apply(void 0,vi(n=[qa(e[0],e[1])]).call(n,li(po(e).call(e,2))));var o,i=e[0],a=e[1],u=Fa(Ca(a));try{for(u.s();!(o=u.n()).done;){var c=o.value;Object.prototype.propertyIsEnumerable.call(a,c)&&(a[c]===Na?delete i[c]:null===i[c]||null===a[c]||"object"!==ji(i[c])||"object"!==ji(a[c])||Ji(i[c])||Ji(a[c])?i[c]=Ga(a[c]):i[c]=za(i[c],a[c]))}}catch(t){u.e(t)}finally{u.f()}return i}function Ga(t){return Ji(t)?qt(t).call(t,(function(t){return Ga(t)})):"object"===ji(t)&&null!==t?za({},t):t}function Ua(t){for(var e=0,r=Ko(t);e<r.length;e++){var n=r[e];t[n]===Na?delete t[n]:"object"===ji(t[n])&&null!==t[n]&&Ua(t[n])}}function Va(t){return"string"==typeof t||"number"==typeof t}var Ja=Pt("splice"),$a=Dt("splice",{ACCESSORS:!0,0:0,1:2}),Wa=Math.max,Ba=Math.min;V({target:"Array",proto:!0,forced:!Ja||!$a},{splice:function(t,e){var r,n,o,i,a,u,c=X(this),s=Y(c.length),f=me(t,s),l=arguments.length;if(0===l?r=n=0:1===l?(r=0,n=s-f):(r=l-2,n=Ba(Wa(B(e),0),s-f)),s+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(o=lt(c,n),i=0;i<n;i++)(a=f+i)in c&&Le(o,i,c[a]);if(o.length=n,r<n){for(i=f;i<s-n;i++)u=i+r,(a=i+n)in c?c[u]=c[a]:delete c[u];for(i=s;i>s-n+r;i--)delete c[i-1]}else if(r>n)for(i=s-n;i>f;i--)u=i+r-1,(a=i+n-1)in c?c[u]=c[a]:delete c[u];for(i=0;i<r;i++)c[i+f]=arguments[i+2];return c.length=s-n+r,o}});var Ka=vt("Array").splice,Ya=Array.prototype,Ha=function(t){var e=t.splice;return t===Ya||t instanceof Array&&e===Ya.splice?Ka:e},Qa=[].slice,Xa=/MSIE .\./.test(xt),Za=function(t){return function(e,r){var n=arguments.length>2,o=n?Qa.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,r)}};V({global:!0,bind:!0,forced:Xa},{setTimeout:Za(o.setTimeout),setInterval:Za(o.setInterval)});var tu=M.setTimeout,eu=function(){function t(e){ue(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return le(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=tu((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Jr(t=Ha(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:o},n}}]),t}(),ru=function(){function t(){ue(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return le(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");Jr(n=vi(o=[]).call(o,li(this._subscribers[t]),li(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=$t(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),nu=(Ci("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ui),M.Set);function ou(t,e){var r;if(void 0===Bn||null==qn(t)){if(Ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return iu(t,e);var n=po(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return iu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function iu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var au=function(){function t(e){ue(this,t),this._pairs=e}return le(t,[{key:jo,value:ko.mark((function t(){var e,r,n,o,i;return ko.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ou(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ma(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:ko.mark((function t(){var e,r,n,o,i;return ko.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ou(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ma(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:ko.mark((function t(){var e,r,n,o;return ko.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ou(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ma(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:ko.mark((function t(){var e,r,n,o;return ko.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ou(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Ma(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return qt(t=li(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return qt(t=li(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return li(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=la(null),r=ou(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Ma(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Vi(this._pairs)}},{key:"toIdSet",value:function(){return new nu(this.toIdArray())}},{key:"toItemSet",value:function(){return new nu(this.toItemArray())}},{key:"cache",value:function(){return new t(li(this._pairs))}},{key:"distinct",value:function(t){var e,r=new nu,n=ou(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=Ma(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Ao({},jo,ko.mark((function t(){var n,o,i,a,u;return ko.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=ou(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=Ma(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=ou(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Ma(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Ao({},jo,ko.mark((function t(){var n,o,i,a,u;return ko.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=ou(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=Ma(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Nn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Ma(r.value,2),a=i[0],u=i[1],c=t(u,a);c>o&&(o=c,n=u)}return n}},{key:"min",value:function(t){var e=Nn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=Ma(r.value,2),a=i[0],u=i[1],c=t(u,a);c<o&&(o=c,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=ou(this._pairs);try{for(n.s();!(r=n.n()).done;){var o=Ma(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Ao({},jo,(function(){var t;return Nn(Wo(t=li(r._pairs)).call(t,(function(t,r){var n=Ma(t,2),o=n[0],i=n[1],a=Ma(r,2),u=a[0],c=a[1];return e(i,c,o,u)})))})))}}]),t}();function uu(t,e){var r=Ko(t);if(Tn){var n=Tn(t);e&&(n=$t(n).call(n,(function(e){return Br(t,e).enumerable}))),r.push.apply(r,n)}return r}function cu(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)Jr(r=uu(Object(n),!0)).call(r,(function(e){Ao(t,e,n[e])}));else if(De)Ae(t,De(n));else{var o;Jr(o=uu(Object(n))).call(o,(function(e){de(t,e,Br(n,e))}))}}return t}function su(t,e){var r;if(void 0===Bn||null==qn(t)){if(Ji(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return fu(t,e);var n=po(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return oo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function fu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function lu(t){var e=function(){if("undefined"==typeof Reflect||!bo)return!1;if(bo.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(bo(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ea(t);if(e){var o=ea(this).constructor;r=bo(n,arguments,o)}else r=n.apply(this,arguments);return Xi(this,r)}}var hu=function(t){Hi(r,ru);var e=lu(r);function r(t,n){var o;return ue(this,r),o=e.call(this),t&&!Ji(t)&&(n=t,t=[]),o._options=n||{},o._data=new Vi,o.length=0,o._idProp=o._options.fieldId||"id",t&&t.length&&o.add(t),o.setOptions(n),o}return le(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=eu.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===ji(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(Ji(t)){var i=qt(t).call(t,(function(t){return t[n._idProp]}));if(ki(i).call(i,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==ji(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=this._idProp,c=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var c=t,s=mi({},r._data.get(e)),f=r._updateItem(c);o.push(f),a.push(c),i.push(s)}else{var l=r._addItem(t);n.push(l)}};if(Ji(t))for(var s=0,f=t.length;s<f;s++)t[s]&&"object"===ji(t[s])?c(t[s]):console.warn("Ignoring input item, which is not an object at index "+s);else{if(!t||"object"!==ji(t))throw new Error("Unknown dataType");c(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return vi(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;Ji(t)||(t=[t]);var o=qt(r=qt(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[n._idProp],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return qa.apply(void 0,vi(e=[{},t]).call(e,n))}(e,r);return n._data.set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:qt(o).call(o,(function(t){return t.id})),oldData:qt(o).call(o,(function(t){return t.oldData})),data:qt(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;Va(t)?(r=t,o=e):Ji(t)?(n=t,o=e):o=t;var i=o&&"Object"===o.returnType?"Object":"Array",a=o&&$t(o),u=[],c=void 0,s=void 0,f=void 0;if(null!=r)(c=this._data.get(r))&&a&&!a(c)&&(c=void 0);else if(null!=n)for(var l=0,h=n.length;l<h;l++)null==(c=this._data.get(n[l]))||a&&!a(c)||u.push(c);else for(var p,v=0,d=(s=li(Xo(p=this._data).call(p))).length;v<d;v++)f=s[v],null==(c=this._data.get(f))||a&&!a(c)||u.push(c);if(o&&o.order&&null==r&&this._sort(u,o.order),o&&o.fields){var y=o.fields;if(null!=r&&null!=c)c=this._filterFields(c,y);else for(var g=0,m=u.length;g<m;g++)u[g]=this._filterFields(u[g],y)}if("Object"==i){for(var b={},_=0,w=u.length;_<w;_++){var O=u[_];b[O[this._idProp]]=O}return b}return null!=r?null!=c?c:null:u}},{key:"getIds",value:function(t){var e=this._data,r=t&&$t(t),n=t&&t.order,o=li(Xo(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,c=o.length;u<c;u++){var s=o[u],f=this._data.get(s);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)i.push(a[l][this._idProp])}else for(var p=0,v=o.length;p<v;p++){var d=o[p],y=this._data.get(d);null!=y&&r(y)&&i.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var _=o[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,O=g.length;w<O;w++)i.push(g[w][this._idProp])}else for(var x=0,k=o.length;x<k;x++){var S=o[x],j=e.get(S);null!=j&&i.push(j[this._idProp])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&$t(e),n=this._data,o=li(Xo(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var c=i[a];t(c,c[this._idProp])}else for(var s=0,f=o.length;s<f;s++){var l=o[s],h=this._data.get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&$t(e),n=[],o=this._data,i=li(Xo(o).call(o)),a=0,u=i.length;a<u;a++){var c=i[a],s=this._data.get(c);null==s||r&&!r(s)||n.push(t(s,c))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?Zt(r=Ji(e)?e:Ko(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;Wo(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");Wo(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=Ji(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var c=u[this._idProp];null!=c&&(r.push(c),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(Va(t)?e=t:t&&"object"===ji(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=li(Xo(e=this._data).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(this._data.get(r[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=su(No(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=su(No(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=li(Xo(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],c=e.get(u)[t],s=!1,f=0;f<o;f++)if(n[f]==c){s=!0;break}s||void 0===c||(n[o]=c,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=sa()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Mo(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,cu(cu({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new au(Ao({},jo,ko.mark((function r(){var n,o,i,a;return ko.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=su(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new au(Ao({},jo,ae(r=xo(this._data)).call(r,this._data)))}}]),r}();function pu(t){var e=function(){if("undefined"==typeof Reflect||!bo)return!1;if(bo.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(bo(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ea(t);if(e){var o=ea(this).constructor;r=bo(n,arguments,o)}else r=n.apply(this,arguments);return Xi(this,r)}}var vu=function(t){Hi(r,ru);var e=pu(r);function r(t,n){var o,i;return ue(this,r),(i=e.call(this)).length=0,i._ids=new nu,i._options=n||{},i._listener=ae(o=i._onEvent).call(o,Qi(i)),i.setData(t),i}return le(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:$t(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:$t(this._options)}),o=0,i=n.length;o<i;o++){var a=n[o];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new hu;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:$t(this._options)}),e=li(this._ids),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var c=t[a];r[c]=!0,this._ids.has(c)||(n.push(c),this._ids.add(c))}for(var s=0,f=e.length;s<f;s++){var l=e[s],h=this._data.get(l);null==h?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(h),this._ids.delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;Va(t)||Ji(t)?(n=t,r=e):r=t;var o=mi({},this._options,r),i=$t(this._options),a=r&&$t(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=$t(this._options),n=null!=t?$t(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,o=$t(this._options),i=e&&$t(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,Jr(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,o=$t(this._options),i=e&&$t(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,qt(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Ao({},jo,ae(e=Xo(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e="This data view has already been disposed of.";de(this,"_data",{get:function(){throw new Error(e)},set:function(){throw new Error(e)},configurable:!1})}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,o=[],i=[],a=[],u=[],c=[],s=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var h=n[f];this.get(h)&&(this._ids.add(h),o.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(i.push(d),c.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),o.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),s.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),s.push(e.oldData[y]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:c},r),a.length&&this._trigger("remove",{items:a,oldData:s},r)}}}]),r}();export{Na as DELETE,hu as DataSet,au as DataStream,vu as DataView,eu as Queue,he as createNewDataPipeFrom};
//# sourceMappingURL=vis-data.min.js.map
